@echo off

rem --- Clean up ---
del MediaInfoLib_Source.7z
rmdir MediaInfoLib_Source /S /Q
mkdir MediaInfoLib_Source


rem --- Copying : Include ---
xcopy ..\Source\MediaInfo\MediaInfo.h MediaInfoLib_Source\Include\MediaInfo\
xcopy ..\Source\MediaInfo\MediaInfoList.h MediaInfoLib_Source\Include\MediaInfo\
xcopy ..\Source\MediaInfoDLL\MediaInfoDLL.h MediaInfoLib_Source\Include\MediaInfoDLL\
xcopy ..\Source\MediaInfoDLL\MediaInfoDLL.def MediaInfoLib_Source\Include\MediaInfoDLL\
xcopy ..\Source\MediaInfoDLL\MediaInfoDLL.pas MediaInfoLib_Source\Include\MediaInfoDLL\
xcopy ..\Source\MediaInfoDLL\MediaInfoDLL.cs MediaInfoLib_Source\Include\MediaInfoDLL\
xcopy ..\Source\MediaInfoDLL\MediaInfoDLL.jsl MediaInfoLib_Source\Include\MediaInfoDLL\
xcopy ..\Source\MediaInfoDLL\MediaInfoDLL.vb MediaInfoLib_Source\Include\MediaInfoDLL\
xcopy ..\Source\MediaInfoDLL\MediaInfoDLL.java MediaInfoLib_Source\Include\MediaInfoDLL\

rem --- Copying : Documentation ---
mkdir Doc
cd ..\Source\Doc
..\..\..\Shared\Binary\Doxygen Doxygen
cd ..\..\Release
mkdir MediaInfoLib_Source\Doc\
xcopy Doc\*.* MediaInfoLib_Source\Doc\
rmdir Doc /S /Q
xcopy ..\Source\Doc\*.html MediaInfoLib_Source\ /S

@rem --- Copying : Sources ---
xcopy ..\Source\*.cpp MediaInfoLib_Source\Source\ /S
xcopy ..\Source\*.h MediaInfoLib_Source\Source\ /S
xcopy ..\Source\*.rc MediaInfoLib_Source\Source\ /S
xcopy ..\Source\*.def MediaInfoLib_Source\Source\ /S
xcopy ..\Source\*.pas MediaInfoLib_Source\Source\ /S
xcopy ..\Source\*.cs MediaInfoLib_Source\Source\ /S
xcopy ..\Source\*.jsl MediaInfoLib_Source\Source\ /S
xcopy ..\Source\*.vb MediaInfoLib_Source\Source\ /S
xcopy ..\Source\*.java MediaInfoLib_Source\Source\ /S
xcopy ..\Source\*.txt MediaInfoLib_Source\Source\ /S
xcopy ..\Source\*.csv MediaInfoLib_Source\Source\ /S
xcopy ..\Source\*.dfm MediaInfoLib_Source\Source\ /S
xcopy ..\Source\*.au3 MediaInfoLib_Source\Source\ /S
xcopy ..\Source\Doc\* MediaInfoLib_Source\Source\Doc\ /S

@rem --- Copying : Projects ---
xcopy ..\Project\*.bpg MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.bpf MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.bpr MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.dfm MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.cpp MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.bdsgroup MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.bdsproj MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.dpr MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.pas MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.dof MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.dev MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.sln MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.cs MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.csproj MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.jsl MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.vjsproj MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.vbproj MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.vb MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.vc MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.vcproj MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.ico MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.workspace MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.cbp MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.resx MediaInfoLib_Source\Project\ /S
xcopy ..\Project\*.rc MediaInfoLib_Source\Project\ /S
xcopy ..\Project\BCB\*.h MediaInfoLib_Source\Project\BCB\ /S
xcopy ..\Project\MSVC\*.h MediaInfoLib_Source\Project\MSVC\ /S
xcopy ..\Project\BCB\*.res MediaInfoLib_Source\Project\BCB /S
xcopy ..\Project\Delphi\*.res MediaInfoLib_Source\Project\Delphi /S
xcopy ..\Project\MSVB\*.rc MediaInfoLib_Source\Project\MSVB\ /S
xcopy "..\Project\MSVB\Example\My Project\*.*" "MediaInfoLib_Source\Project\MSVB\Example\My Project\" /Y
xcopy "..\Project\MSVB\Example VB6\*.*" "MediaInfoLib_Source\Project\MSVB\Example VB6\" /Y
xcopy ..\Project\GCC\Make* MediaInfoLib_Source\Project\GCC\ /S
xcopy ..\Project\GCC\*.mak MediaInfoLib_Source\Project\GCC\ /S
xcopy ..\Project\Java\*.bat MediaInfoLib_Source\Project\Java\ /S
xcopy ..\Project\Java\*.sh MediaInfoLib_Source\Project\Java\ /S
xcopy ..\Project\Java\*.java MediaInfoLib_Source\Project\Java\ /S
xcopy ..\Project\Java\*.txt MediaInfoLib_Source\Project\Java\ /S

@rem --- Copying : Release ---
xcopy *.txt MediaInfoLib_Source\Release\
xcopy *.bat MediaInfoLib_Source\Release\
xcopy *.ogg MediaInfoLib_Source\Release\
xcopy BCB\*.txt MediaInfoLib_Source\Release\BCB\ /S
xcopy MSVC\*.txt MediaInfoLib_Source\Release\MSVC\ /S
xcopy GCC_MinGW32\*.txt MediaInfoLib_Source\Release\GCC_MinGW32\ /S
xcopy GCC_Linux_i386\*.txt MediaInfoLib_Source\Release\GCC_Linux_i386\ /S

@rem --- Copying : Contrib ---
xcopy ..\Contrib\* MediaInfoLib_Source\Contrib\ /S

rem --- Copying : Information files ---
copy ..\*.txt MediaInfoLib_Source\

rem --- Copying : CVS files ---
copy ..\*.cvsignore MediaInfoLib_Source\


rem --- Compressing Archive ---
if "%2"=="SkipCompression" goto SkipCompression
cd MediaInfoLib_Source
..\..\..\Shared\Binary\Win32\7-zip\7z a -r -t7z -mx9 ..\MediaInfo_Lib_Source.7z *
cd ..
:SkipCompression

rem --- Clean up ---
if "%1"=="SkipCleanUp" goto SkipCleanUp
rmdir MediaInfoLib_Source /S /Q
:SkipCleanUp
